
#include <mega128.h> 
#include <delay.h>
#include <string.h>
#include <stdio.h>
#include "def.h"
#include "LCD_3320.h"
#include "LMX2306.h"
#include "displ.h"

//##########################   
#ifdef TIC_154 //       TIC154
    // ******************************  
    //   
    #define MS_ModelPictureX  0 //  ,     
    #define MS_ModelPictureY  0 //  , Y
    #define MS_ModelNameX    24 //  ,     
    #define MS_ModelNameY     0 //  , Y
    #define MS_HeadLineY      0 //  , Y
    #define MS_Mode_TCutX    50 //      .,     
    #define MS_Mode_TCutY    57 //      ., Y
    // 
    #define MS_TimerY 35    //  ,Y
    #define MS_TimerSymW 6  //   
    //  
    #define VertTrimScaleOffset 25 //    .    . 
    #define HorzTrimScaleOffset 6  //  /  .    . 
    #define TrimScaleGrade 4 //   
    #define TrimScaleCuts 8  //    
    #define TrimScaleHalfLen TrimScaleGrade*(TrimScaleCuts/2) //   
    #define TrimScaleLen TrimScaleGrade*TrimScaleCuts //  
    #define TrimPointerDivider 5
    // 
    #define BatVoltageOffsetX 15    // , X       
    #define BatVoltageOffsetY 12    // , Y       
    #define BatBarLtUpX 15          //   ,X            
    #define BatBarLtUpY 11          //   ,Y
    #define BatBarH      6          //                  
    #define BatBarW     38          // () 
    #define BatSymTab    3          //    /
    #ifdef Use_Font_8x8
        #define BatSymW  8   
    #else
        #define BatSymW  LCD_get_char_len(129) //  ""
    #endif    
    // 
    #define AntCurrentOffsetX 80    // , X         
    #define AntCurrentOffsetY 12    // , Y         
    #define AntBarLtUpX 80          //   ,X          
    #define AntBarLtUpY 11          //   ,Y     
    #define AntBarH      6          //                    
    #define AntBarW     38          // () 
    #define AntSymTab    3          //    /
    #ifdef Use_Font_8x8
        #define AntSymW  8   
    #else
        #define AntSymW  LCD_get_char_len(130) //  ""
    #endif

    // ******************************  
    // ++++  Model
    // --  Controls
    // MM -> Model -> Controls -> "ControlName"
    #define DC_CtrlNameX     5
    #define DC_CtrlMinX     50   
    #define DC_CtrlMaxX     85   
    #define DC_SCtrlNameY   20
    #define DC_DCtrlNameY   35
    #define DC_CurveY       50

    // MM -> Model -> Controls -> "CtrlName" -> Curve
    #define GraphOnCenter         //   (  ),   (  )
    //#define Graph PrecisionHigh //     
                                  // ValueDivider (, , Deltha_Y)
                                  //   CvAreaHalfHgth
                                  //!!!   (s)printf  "float"   !!!
                                  //Project -> Configure -> "C ompiller" -> "(s)printf Features"  
    #ifdef GraphOnCenter
        #define CvAreaCenX      50  //   , X
        #define CvAreaCenY      37  //   , Y
        #define CvHorStep       10  //    ,   = 6 
        #define CvAreaHalfHgth  25  //    
        #define GrphLblTab      15  //     
        #define ExpLabelY       25  //   
        #define ExpParamY       35  //   
        #ifdef Graph PrecisionHigh
            #define ValueDivider  100/CvAreaHalfHgth  
        #else
            #define ValueDivider  4
        #endif
        //   #define:
            #define CvAreaLeft  CvAreaCenX-(CvHorStep*3)     
            #define CvAreaRight CvAreaCenX+(CvHorStep*3)     
            #define CvAreaTop   CvAreaCenY-CvAreaHalfHgth     
            #define CvAreaBot   CvAreaCenY+CvAreaHalfHgth
            #define ExpLabelX   CvAreaRight+GrphLblTab //     4 !!!
            #define ExpParamX   CvAreaRight+GrphLblTab //     4 !!!
    #else
        #define CvAreaCenX      WidthS/2                //   , X
        #define CvAreaCenY      HeightS/2               //   , Y
        #define CvHorStep       13                      //    ,   = 6 
        #define CvAreaHalfHgth  20                      //    
        #define ExpLabelX       (WidthS/2)-4*8          // "Exp:" = 4 
        #define ExpLabelY       HeightS-CharHeight-1    //   
        #define ExpParamX       (WidthS/2)+1*8
        #define ExpParamY       HeightS-CharHeight-1    //   
        #ifdef Graph PrecisionHigh
            #define ValueDivider  100/CvAreaHalfHgth  
        #else
            #define ValueDivider  5
        #endif
        //   #define:
            #define CvAreaLeft  CvAreaCenX-(CvHorStep*3)     
            #define CvAreaRight CvAreaCenX+(CvHorStep*3)     
            #define CvAreaTop   CvAreaCenY-CvAreaHalfHgth     
            #define CvAreaBot   CvAreaCenY+CvAreaHalfHgth
    #endif
      
    // --  Channels
    // MM -> Model -> Channels -> ChannelX
    #define MCh_ParamNameX   3
    #define MCh_ParamValueX 85
    #define MCh_UpStringY   11
    #define MCh_StringStepY  9 
    #define MCh_BoxAddHgtUp  1
    #define MCh_BoxHight     7 
    #define MCh_BoxWidth    80
    #define MCh_LngBoxWidth WidthS-6  
    // MM -> Model -> Channels -> ChannelX -> Mixer
    #define MCM_ParamNameX   3 
    #define MCM_ParamValueX 85 
    #define MCM_UpStringY   11 
    #define MCM_StringStepY  9 
    #define MCM_BoxAddHgtUp  1 
    #define MCM_BoxHight     7 
    #define MCM_BoxWidth    80
    // --  Name (  )   
    // MM -> Model -> Name                      
    #define M_ModelNameX    34
    #define M_ModelNameY    30
    // --  Type
    // MM -> Model -> Type (  )
    #define M_ModelTypeX    45
    #define M_ModelTypeY    30
    // XXXXXXX (    )
    #define M_ChnFrqHeadX    2
    #define M_ChnFrqValueX  45
    #define M_ChanlY        20
    #define M_FrqY          29
    // --  
    // MM -> Model -> Coding (  )
    #define M_ModulatNameX  50
    #define M_ModulatNameY  30
    // --                          
    // MM -> Model -> Max channel (  )
    #define M_ChannelPcsX   60
    #define M_ChannelPcsY   30
    // --  Timer  
    // MM -> Model -> Timer -> Set Timer ( )
    #define M_TimerSetX     50
    #define M_TimerSetY     30
    // MM -> Model -> Timer -> Timer Modes (  )
    #define M_TimerRegSelX  50
    #define M_TimerRegSelY  30
    // --  Modes copy (   )    Copy (   ) 
    // MM -> Model -> Modes copy      MM -> Copy                
    #define M_CopyFromX      5
    #define M_CopyFromY     20
    #define M_CopyToX        5
    #define M_CopyToY       35
    #define M_CopyFrameX    50
    #define M_CopyOK_X      50
    #define M_CopyOK_Y      50
    // --  Reset (    )
    // MM -> Model -> Reset                     
    // =     ,  , .   "    " 
    //   (MM -> Options -> Sound)                
    #define M_SoundX        55
    #define M_SoundY        30
    //  (MM -> Options -> Alarms -> Battery)
    #define M_BatteryPosY   20
    #define M_BatThemeX      5
    #define M_BatVoltageX   75
    #define M_BatBarX        0
    #define M_BatteryBarHgt 14
    #define M_BatBarLen     65
    //  (MM -> Options -> Alarms -> Antenna)                                    
    #define M_AntennaX       5
    #define M_AntennaY      30
    //  (MM -> Options -> Tachometer)
    #define M_TachometerX   36
    #define M_TachometerY   30
    //       (MM -> Options -> Version)                           
    #define M_VersionX       0
    #define M_VersionY      20
    #define M_CopyrightX    18
    #define M_CopyrightY    38
    //   (   ,   EEPROM,    Normalize
    #ifndef M_AskSureXY           //     coder.c
        #define M_AskSureXY 
        #define M_AskSureX       2
        #define M_AskSureQuestY 15 
    #endif 
    #define M_AskSureY      25
    #define M_AskSureCanclY 45
    #define M_AskSureRightY 55                               
#endif //       TIC154

//  !!
extern eeprom MODEL_SET EEPR_models[MAX_MODELS];
extern signed int out_ch[MAX_CHANS];
extern unsigned int cur_Batt;
#ifdef AntennaCtrlUse 
    extern unsigned int cur_Power;
    extern unsigned int cur_Antenna;
#endif
extern unsigned int cur_Temperature;
extern signed int dir_Temperature;
extern unsigned char BatCntr[3];
extern unsigned char gAntCntr;
extern bit f_TCut;
extern unsigned int time;
extern bit  f_sound_en;
extern unsigned char g_MainMenuMode;
extern unsigned int gRPM[];
extern signed int CalibrTemperature[2];  
// 

__flash const char *modeNames[2][3] =
   {
     { "Land", "Norm", "Pilot" },
     { "Norm", "IDU", "THL"    }
    };
__flash const char *modulNames[] = { "PPM", "IPPM", "PCM" };
__flash const char *menuT0[] = {
    "Select\t>",
    "Model\t>",
    "Copy\t>",
    "Options\t>"
};
__flash const char *menuT1[] ={
    "Controls\t>",
    "Channels\t>",
    "Name\t>",
    "Type\t>",
    "Frequency\t>",
    "Coding\t>",
    "Max channel\t>",
    "Timer\t>",
    "Modes copy\t>",
    "Reset\t>"
};
__flash const char *menuT2[] = {
    "Ailerons\t>",
    "Elevator\t>",
    "Throttle\t>",
    "Rudder\t>",
    "Switch 1\t>",
    "Switch 2\t>",
    "Switch 3\t>",
    "Add Prop\t>",
    "Virtual 1\t>",
    "Virtual 2\t>",
};
__flash const char *menuCh[]= {
    "Mixer\t>",
    "Normalize\t>",
    "Subtrim",
    "EPA-",
    "EPA+",
    "Reverse"
};
__flash const char *menuT3[] = {
    "Set timer\t>",
    "Timer modes\t>"
};
__flash const char *menuT4[] = {
    "Sound\t>",
    "Alarms\t>",
    "Monitor\t>",
    "Tachometer\t>",
    "Version\t>"
};
__flash const char *menuT5[] = {
    "Channel 1\t>",
    "Channel 2\t>",
    "Channel 3\t>",
    "Channel 4\t>",
    "Channel 5\t>",
    "Channel 6\t>",
    "Channel 7\t>",
    "Channel 8\t>"
};
__flash const char *menuT6[] = {
    "Battery\t>",
    "Antenna\t>"
};

__flash const char *TypesModel[] = { "Plane", "Heli" };
__flash const char *Timer_modes1[] = { "UP", "DOWN","AUTO" };
//__flash const char *Timer_modes2[] = { "Sound ON", "Sound OFF" };
__flash const char *menuT7[]= { "Save", "Cancel", "Restore" };
__flash const char *menuT8[]= { "Warning", "Alarm", "Max" };
__flash char _str_VER[]="v1.9.1, 11/05/10";
__flash char _str_Co[]="mod. EagleB3";
//----------------------------------------------------------------------------------------------------
unsigned char dg_list_topitem;
unsigned char dg_list_selitem;
unsigned char dg_list_cnt;
bit df_edit;
bit df_edit_cur;
bit df_clip;
unsigned char dpos[6];
unsigned char dT[2];
MODEL_SET dcur_model;
DEF_MODE *dcur_mode;
unsigned char dcur_mode_ind;
unsigned char tmp[12];
//----------------------------------------------------------------------------------------------------

void AreYouSure_LR (void) {
  LCD_setxy(M_AskSureX,M_AskSureY);
  LCD_wrsf("Are you sure?", 1);
  LCD_setxy(M_AskSureX,M_AskSureCanclY);
  LCD_wrsf("Left  => Cancel,", 1);
  LCD_setxy(M_AskSureX,M_AskSureRightY);
  LCD_wrsf("Right => YES", 1);  
  LCD_refresh();
}
//----------------------------------------------------------------------------------------------------

void list_draw_scrollbar (void)
{   unsigned char l;
    unsigned int pos;

    l=MAX_LIST_LINES*9; 
    LCD_line((WidthS-2), 11, (WidthS-2), 11+l-1, 1);
    if(dg_list_cnt<=MAX_LIST_LINES) return;
    pos=l-(5+2); 
//    pos*=dg_list_topitem; pos/=(dg_list_cnt-MAX_LIST_LINES); pos+=12;
    pos*=dg_list_selitem; pos/=(dg_list_cnt-1); pos+=12;
    LCD_line((WidthS-3), pos, (WidthS-3), pos+4, 1);
    LCD_line((WidthS-2), pos, (WidthS-2), pos+4, 0);
    LCD_line((WidthS-1), pos, (WidthS-1), pos+4, 1);
}
//----------------------------------------------------------------------------------------------------

void list_displ(__flash const char **list)
{   unsigned char i, y, att, n;

    n=dg_list_topitem;
    for(i=0, y=11; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=9){
        LCD_setxy(2, y);
        if(n==dg_list_selitem) { att=0; LCD_fillrect(0, y-1, (WidthS-6), y+7, 1); }
        else att=1;
        LCD_wrsf(list[n], att);
    };
    list_draw_scrollbar();  
}
//----------------------------------------------------------------------------------------------------

void list_displ_names (void)
{   unsigned char i, j, y, att, n;

    n=dg_list_topitem;
    for(i=0, y=11; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=9) {
        LCD_setxy(2, y);
        if(n==dg_list_selitem) {
            att=0;
            LCD_fillrect(0, y-1, (WidthS-6), y+7, 1);
        }
        else att=1;
        for(j=0; j<8; j++) LCD_char(EEPR_models[n].name[j], att);
    };
    list_draw_scrollbar();  
}
//----------------------------------------------------------------------------------------------------
void displ_contr_short(unsigned char ind, unsigned char x, unsigned char y, unsigned char att)
{   flash char *p;

    LCD_setxy(x,y); p=menuT2[ind];
    while(*p>=' ') { 
        LCD_char(*p, att);
        p++;
    }
    if(att==0) LCD_frame(x);
}
//----------------------------------------------------------------------------------------------------
void displ_controls (char N, char sel)
{   unsigned char  att, ind;
    if (N<=3 && N!=2) { 
        //     
        ind=N; if(N>2) ind=2;
        LCD_setxy(DC_CtrlNameX,DC_SCtrlNameY); LCD_wrsf("Rate", 1);  
        sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].minRates);
        if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMinX,DC_SCtrlNameY); LCD_wrs(tmp, att);
        sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].maxRates);
        if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMaxX,DC_SCtrlNameY); LCD_wrs(tmp, att);      
        LCD_setxy(DC_CtrlNameX, DC_DCtrlNameY); LCD_wrsf("DRate", 1); 
        sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].minDRates);
        if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=255;
        LCD_setxy(DC_CtrlMinX, DC_DCtrlNameY); LCD_wrs(tmp, att);
        sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].maxDRates);   
        if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=255;
        LCD_setxy(DC_CtrlMaxX, DC_DCtrlNameY); LCD_wrs(tmp, att);
        if (sel==4) att=0; else att=1;
        LCD_setxy(DC_CtrlMinX, DC_CurveY); LCD_wrsf("Curve >", att);  
    }
    else if (N==2) { 
      // 
        LCD_setxy(DC_CtrlNameX,DC_SCtrlNameY); LCD_wrsf("Rate", 1);  
        sprintf(tmp,"%-i",dcur_mode->contr_tr.minRates);
        if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMinX,DC_SCtrlNameY); LCD_wrs(tmp, att);
        sprintf(tmp,"%-i",dcur_mode->contr_tr.maxRates);
        if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMaxX,DC_SCtrlNameY); LCD_wrs(tmp, att);
        LCD_setxy(DC_CtrlNameX, DC_DCtrlNameY); LCD_wrsf("Tcut", 1); 
        sprintf(tmp,"%-i",dcur_mode->contr_tr.tcut);
        if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMinX, DC_DCtrlNameY); LCD_wrs(tmp, att);
        if (sel==3) att=0; else att=1;
        LCD_setxy(DC_CtrlMinX, DC_CurveY);  LCD_wrsf("Curve >", att);  
    }
    else if(N>=4 && N<=6)  {
        //  
        ind=N-4;
        LCD_setxy(DC_CtrlNameX,DC_SCtrlNameY); LCD_wrsf("Rate", 1);  
        sprintf(tmp,"%-i",dcur_mode->contr_d[ind].minRates);
        if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMinX,DC_SCtrlNameY); LCD_wrs(tmp, att);
        sprintf(tmp,"%-i",dcur_mode->contr_d[ind].maxRates);
        if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMaxX,DC_SCtrlNameY); LCD_wrs(tmp, att);
        LCD_setxy(DC_CtrlNameX, DC_DCtrlNameY); LCD_wrsf("Delay", 1); 
        sprintf(tmp,"%i.%i",dcur_mode->contr_d[ind].delay/10, dcur_mode->contr_d[ind].delay%10);
        if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMinX, DC_DCtrlNameY); LCD_wrs(tmp, att);
    }
    else if (N==7) {
        //  
        LCD_setxy(DC_CtrlNameX,DC_SCtrlNameY); LCD_wrsf("Rate", 1);  
        sprintf(tmp,"%-i",dcur_mode->contr_ap.minRates);
        if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMinX,DC_SCtrlNameY); LCD_wrs(tmp, att);
        sprintf(tmp,"%-i",dcur_mode->contr_ap.maxRates);
        if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMaxX,DC_SCtrlNameY); LCD_wrs(tmp, att);      
        if (sel==2) att=0; else att=1;
        LCD_setxy(DC_CtrlMinX, DC_CurveY);  LCD_wrsf("Curve >", att);  
    }
    else if(N>=8) {
        //  
        ind=N-8;
        LCD_setxy(DC_CtrlNameX,DC_SCtrlNameY); LCD_wrsf("Rate", 1);  
        sprintf(tmp,"%-i",dcur_mode->contr_v[ind].minRates);
        if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMinX,DC_SCtrlNameY); LCD_wrs(tmp, att);
        sprintf(tmp,"%-i",dcur_mode->contr_v[ind].maxRates);
        if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(DC_CtrlMaxX,DC_SCtrlNameY); LCD_wrs(tmp, att);      
        LCD_setxy(DC_CtrlNameX, DC_DCtrlNameY); LCD_wrsf("From:", 1);
        if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1; 
        displ_contr_short(dcur_mode->contr_v[ind].from, DC_CtrlMinX, DC_DCtrlNameY, att);
        if (sel==3) att=0; else att=1;
        LCD_setxy(DC_CtrlMinX, DC_CurveY); LCD_wrsf("Curve >", att);  
    };
}
//----------------------------------------------------------------------------------------------------
void displ_curve (unsigned char N, unsigned char sel) {
    // MM -> Model -> Controls -> "CtrlName" -> Curve
    char Y[7];
    int i;
    unsigned char x, att, ind;
    char *val;
    #ifdef Graph PrecisionHigh
        float Deltha_Y; 
    #else    
        char Deltha_Y;
    #endif    

    if (N<=3 && N!=2) {
        ind=N; if(N>2) ind=2;
        val=dcur_mode->contr_ab[ind].cur_nodes;
        }
    else if(N==2) val=dcur_mode->contr_tr.cur_nodes;
    else if(N==7) val=dcur_mode->contr_ap.cur_nodes;
    else if(N>=8) val=dcur_mode->contr_v[N-8].cur_nodes;
    LCD_rectangle(CvAreaLeft,CvAreaTop, CvAreaRight, CvAreaBot, 1); //  
    LCD_dashline(CvAreaLeft,CvAreaCenY, CvAreaRight, CvAreaCenY);   //  .
    for(i=0, x=(CvAreaLeft+CvHorStep); i<5; i++, x+=CvHorStep) {    // 5 .
        LCD_dashline(x, CvAreaTop, x, CvAreaBot);
    };
    for(i=0; i<7; i++) {                    //   
          Deltha_Y=val[i+1]/ValueDivider;   // , .           
          Y[i]=CvAreaCenY-Deltha_Y;         //  Y   
    };        
    for(i=0, x=CvAreaLeft; i<6; i++, x+=CvHorStep) { //   
        LCD_line(x, Y[i], x+CvHorStep, Y[i+1], 1); 
    };    
    if(sel) {
        sprintf(tmp,"%i",val[sel]);
        i=sel-1;
        LCD_rectangle(CvAreaLeft+(i*CvHorStep)-2, Y[i]+2, CvAreaLeft+(i*CvHorStep)+2, Y[i]-2,1);
        
        LCD_setxy(ExpLabelX, ExpLabelY); 
        if (!df_edit) att=1; else att=df_clip;
        LCD_wrs(tmp, att);
    }
     else {
        LCD_setxy(ExpLabelX, ExpLabelY);
        LCD_wrsf("Exp:", 1);
        if (!df_edit) att=0; else att=df_clip;
        LCD_setxy(ExpParamX, ExpParamY);
        if(val[sel]>100) LCD_wrsf("free", att);
        else {
            sprintf(tmp,"%i", val[sel]); LCD_wrs(tmp, att); 
        };
    };
}
//----------------------------------------------------------------------------------------------------

void displ_channel (char ch_ind) {
    // MM -> Model -> Channels -> ChannelX
    unsigned char i, n, y, att;
    CHANNEL *ch;

    ch=&dcur_model.channels[ch_ind];
    for(i=0, n=dg_list_topitem, y=MCh_UpStringY; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=MCh_StringStepY) {
        // 
        LCD_setxy(MCh_ParamNameX,y);      
        att=1;
        //     
        if(n<2) {
            //   (Mixer  Normalize,    )
            if(n==dg_list_selitem) { att=0; LCD_fillrect(0, y-MCh_BoxAddHgtUp, MCh_LngBoxWidth, y+MCh_BoxHight, 1); } 
            LCD_wrsf(menuCh[n], att);
        }
        else {
            //  ( )
            if(n==dg_list_selitem && !df_edit) { att=0; LCD_fillrect(0, y-MCh_BoxAddHgtUp, MCh_BoxWidth, y+MCh_BoxHight, 1); }
            LCD_wrsf(menuCh[n], att);
            //  
            LCD_setxy(MCh_ParamValueX, y);
            if(n==dg_list_selitem && df_edit) att=df_clip; else att=1;
            switch(n) {
                case 2: sprintf(tmp, "%i", ch->subtrimmer); break;
                case 3: sprintf(tmp, "%i", ch->epa[0]); break;
                case 4: sprintf(tmp, "%i", ch->epa[1]); break;
                case 5: if(ch->reverse==-1) strcpyf(tmp, "Yes"); else strcpyf(tmp, "No"); break;
            };
           LCD_wrs(tmp, att);
        };
    };
    list_draw_scrollbar();
}
//----------------------------------------------------------------------------------------------------
void displ_mixer (unsigned char ch_ind) {
    // MM -> Model -> Channels -> ChannelX -> Mixer
    unsigned char i, n, y, att;
    flash char *p;
    for(i=0, n=dg_list_topitem, y=MCM_UpStringY; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=MCM_StringStepY) {
        LCD_setxy(MCM_ParamNameX,y);
        if(n==dg_list_selitem && !df_edit) { att=0; LCD_fillrect(0, y-MCM_BoxAddHgtUp, MCM_BoxWidth, y+MCM_BoxHight, 1); } else att=1;
        p=menuT2[n];
        while(*p>=' ') {
            LCD_char(*p, att); p++; 
        };
        if(n==dg_list_selitem && df_edit) att=df_clip; else att=1;
        LCD_setxy(MCM_ParamValueX, y);
        sprintf(tmp, "%i", dcur_mode->mixer[ch_ind][n]);
        LCD_wrs(tmp, att);
    };
    list_draw_scrollbar();  
} 
//----------------------------------------------------------------------------------------------------

void displ_monitor(void) {
    unsigned char i, j, y, n, y1, x;
    signed int v;

#define Displ_Mon_OffsetX    2
#define Displ_Mon_OffsetY   11
#define Displ_Mon_StepY      9
// 14
// 78 //(+64)
// 17
// 7 (step Y)
// 4 (step X)    

    for(i=0, n=dg_list_selitem, y=Displ_Mon_OffsetY; i<MAX_LIST_LINES && n<dcur_model.num_ch; i++, n++, y+=Displ_Mon_StepY) {
        v=out_ch[n]-2250; // +- 900
        if(dpos[3]==0) {
            sprintf(tmp, "%-i", n+1);
            LCD_setxy(Displ_Mon_OffsetX,y); LCD_wrs(tmp, 1);
            y1=y+7;
            LCD_line(14, y1, 78, y1, 1);
            for(j=0, x=14; j<17; j++, x+=4) {
                LCD_pixel(x, y1-1, 1); 
                if(!(j%2)) LCD_pixel(x, y1-2, 1); 
            };
            v*=32; v/=900; v+=46;
            LCD_pixel(v, y1-1, 1);
            LCD_line(v-1, y1-2, v+1, y1-2, 1);
            LCD_line(v-2, y1-3, v+2, y1-3, 1);
        }
        else {
            v*=10; v/=75;
            sprintf(tmp, "Ch%-i %-i", n+1, v);
            LCD_setxy(Displ_Mon_OffsetX,y); LCD_wrs(tmp, 1);
        };
    };
}   
//----------------------------------------------------------------------------------------------------

void displ_trimmer (void)
{   unsigned char i, x, y, v;
    //  
    // ,  
    x=0;
    LCD_line(x, VertTrimScaleOffset, x, VertTrimScaleOffset+TrimScaleLen, 1);
    for(i=0, y=VertTrimScaleOffset; i<TrimScaleCuts+1; i++, y=y+TrimScaleGrade) { 
        LCD_pixel(x+1, y, 1); if(!(i%2)) LCD_pixel(x+2, y, 1); 
    };
    v=(dcur_mode->trimmers[2]/-(TrimPointerDivider))+(VertTrimScaleOffset+TrimScaleHalfLen); //v = .  
    // 
    LCD_pixel(x+1, v, 1);
    LCD_line(x+2, v-1, x+2, v+1,1);
    LCD_line(x+3, v-2, x+3, v+2,1);
    
    // , 
    x=(WidthS-1);
    LCD_line(x, VertTrimScaleOffset, x, VertTrimScaleOffset+TrimScaleLen, 1);
    for(i=0, y=VertTrimScaleOffset; i<TrimScaleCuts+1; i++, y=y+TrimScaleGrade) {                                               
        LCD_pixel(x-1, y, 1); if(!(i%2)) LCD_pixel(x-2, y, 1); 
    };
    v=(dcur_mode->trimmers[1]/-(TrimPointerDivider))+(VertTrimScaleOffset+TrimScaleHalfLen);
    LCD_pixel(x-1, v, 1);
    LCD_line(x-2, v-1, x-2, v+1, 1);
    LCD_line(x-3, v-2, x-3, v+2, 1);
    
    // , 
    y=(HeightS-3);  
    LCD_line(HorzTrimScaleOffset, y, HorzTrimScaleOffset+TrimScaleLen, y, 1);
    for(i=0, x=HorzTrimScaleOffset; i<TrimScaleCuts+1; i++, x=x+TrimScaleGrade) {
        LCD_pixel(x, y-1, 1); if(!(i%2)) LCD_pixel(x, y-2, 1); 
    };
    v=(dcur_mode->trimmers[3]/TrimPointerDivider)+(HorzTrimScaleOffset+TrimScaleHalfLen); // .  =   
    LCD_pixel(v, y-1, 1);
    LCD_line(v-1, y-2, v+1, y-2, 1);
    LCD_line(v-2, y-3, v+2, y-3, 1);
    
    // , 
    y=(HeightS-3);
    LCD_line((WidthS-(1+HorzTrimScaleOffset+TrimScaleLen)), y, (WidthS-(1+HorzTrimScaleOffset)), y, 1);
    for(i=0, x=(WidthS-(1+HorzTrimScaleOffset+TrimScaleLen)); i<TrimScaleCuts+1; i++, x=x+TrimScaleGrade) {    //x=47
        LCD_pixel(x, y-1, 1); if(!(i%2)) LCD_pixel(x, y-2, 1);
      };
    v=(dcur_mode->trimmers[0]/TrimPointerDivider)+(WidthS-(1+HorzTrimScaleOffset+TrimScaleHalfLen)); // .  =   
    LCD_pixel(v, y-1, 1);
    LCD_line(v-1, y-2, v+1, y-2, 1);
    LCD_line(v-2, y-3, v+2, y-3, 1);
}
//----------------------------------------------------------------------------------------------------

/*sprintf(tmp,"%-i", VOut[0]);
LCD_setxy(0, 0);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[1]);
LCD_setxy(0, 9);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[2]);
LCD_setxy(0, 18);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[3]);
LCD_setxy(0, 27);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[4]);
LCD_setxy(0, 36);
LCD_wrs(tmp, 1);*/
//----------------------------------------------------------------------------------------------------

void main_scr (void)
{   unsigned char i;
    char min[2], sec[2];
    signed int k;
    // ---  ---    
        
    //  
    LCD_setxy(MS_ModelPictureX, MS_ModelPictureY);
    if(dcur_model.type==1) {    //                                                                 
        LCD_char(125,1);
        LCD_char(126,1); 
    } 
    else {                      // 
        LCD_char(127,1);
        LCD_char(128,1); 
    }; 
    //        
    LCD_setxy(MS_ModelNameX,MS_ModelNameY);
    for(i=0; i<8; i++) LCD_char(dcur_model.name[i], 1);
    // 
    LCD_dashline(0, MS_HeadLineY, WidthS, MS_HeadLineY);    

    // ---   ---
    //   / 
    LCD_setxy(MS_Mode_TCutX,MS_Mode_TCutY);  
    if(f_TCut) LCD_wrsf("TCut", df_clip); 
    else LCD_wrsf(modeNames[dcur_model.type][dcur_mode_ind],1);
    //       
    displ_trimmer();
    //    
    min[0]=(time/600)%10;
    min[1]=(time/60)%10;
    sec[0]=(time%60)/10;
    sec[1]=time%10;
    /*  Denn
    min_all[0]=(time_all/600)%10;   // new
    min_all[1]=(time_all/60)%10;    // new
    sec_all[0]=(time_all%60)/10;    // new
    sec_all[1]=time_all%10;         // new
    */

    switch(g_MainMenuMode) {
        case 0:
            // 
            LCD_setxy(((WidthS/2)-30),28);  //  35 ----    //LCD_setxy(12,24);
            LCD_deg12x16(min[0], 1);                       
            LCD_setxy((((WidthS/2)-18)),28); //LCD_setxy((((WidthS/2)-30)+12),24);
            LCD_deg12x16(min[1], 1);                       
            LCD_setxy((((WidthS/2)-6)),28);  //LCD_setxy((((WidthS/2)-30)+24),24);
            LCD_deg12x16(10, 1); // ':'                    
            LCD_setxy((((WidthS/2)+6)),28);  //LCD_setxy((((WidthS/2)-30)+36),24);
            LCD_deg12x16(sec[0], 1);                       
            LCD_setxy((((WidthS/2)+18)),28); //LCD_setxy((((WidthS/2)-30)+48),24);
            LCD_deg12x16(sec[1], 1);

            /*  Denn
            // new     
            LCD_setxy(((WidthS/2)-19),45);
            LCD_char(min[0]+48, 1);         // _all
            LCD_setxy(((WidthS/2)-10),45);
            LCD_char(min_all[1]+48, 1);
            LCD_setxy(((WidthS/2)-1),45);
            LCD_wrsf(":", 1);
            LCD_setxy(((WidthS/2)+3),45);
            LCD_char(sec_all[0]+48, 1);
            LCD_setxy(((WidthS/2)+12),45);
            LCD_char(sec_all[1]+48, 1);
            // new  
            */
          
            //  = 
            k=(cur_Batt/5);
            if((k>BatCntr[0] && k>BatCntr[1]) || df_clip) {
                LCD_setxy(BatBarLtUpX-BatSymW-BatSymTab, BatBarLtUpY);       //      ""  
                LCD_char(129, 1);
            };
            LCD_rectangle(BatBarLtUpX,BatBarLtUpY, BatBarLtUpX+BatBarW,BatBarLtUpY+BatBarH, 1);
            k-=(int)BatCntr[1]; k*=(BatBarW-1); k/=(int)(BatCntr[2]-BatCntr[1]);             
            k=k+BatBarLtUpX; if(k>(BatBarLtUpX+BatBarW-1)) k=(BatBarLtUpX+BatBarW-1);
            if(k>=BatBarLtUpX+1) {
                for (i=BatBarLtUpY+1; i<BatBarLtUpY+BatBarH; i++) {                          
                        //LCD_line(BatBarLtUpX+1, i, k+3, i, 1); //  k "+3"?!
                        LCD_line(BatBarLtUpX+1, i, k, i, 1);
                             
                };
            };
            #ifdef AntennaCtrlUse    
                //  =  
                LCD_setxy(AntBarLtUpX-AntSymW-AntSymTab, AntBarLtUpY); LCD_char(130, 1);       //      ""  
                LCD_rectangle(AntBarLtUpX,AntBarLtUpY, AntBarLtUpX+AntBarW,AntBarLtUpY+AntBarH, 1);  
                k=((cur_Power*5)/2); k*=(AntBarW-1); k/=500; 
                k=k+AntBarLtUpX; if(k>AntBarLtUpX+AntBarW-1) k=AntBarLtUpX+AntBarW-1;  
                if (k>=AntBarLtUpX+1) {
                    for (i=AntBarLtUpY+1; i<AntBarLtUpY+AntBarH; i++) {                
                            LCD_line(AntBarLtUpX+1, i, k+3, i, 1);
                        };
                };
            #endif
        break;
        case 1:
        // 
            LCD_setxy(((WidthS/2)-(MS_TimerSymW*5)),MS_TimerY);           // . 
            LCD_deg12x16(min[0], 1);
            LCD_setxy((((WidthS/2)-(MS_TimerSymW*3))),MS_TimerY);         // . 
            LCD_deg12x16(min[1], 1);
            LCD_setxy((((WidthS/2)-MS_TimerSymW)),MS_TimerY);             // 
            LCD_deg12x16(10, 1); // ':'
            LCD_setxy((((WidthS/2)+MS_TimerSymW)),MS_TimerY);             // . 
            LCD_deg12x16(sec[0], 1);
            LCD_setxy((((WidthS/2)+(MS_TimerSymW*3))),MS_TimerY);         // . 
            LCD_deg12x16(sec[1], 1);
            /*  Denn
            // new     
            LCD_setxy(8,24);
            LCD_char(min_all[0]+48, 1);
            LCD_setxy(17,24);
            LCD_char(min_all[1]+48, 1);
            LCD_setxy(26,24);
            LCD_wrsf(":", 1);
            LCD_setxy(30,24);
            LCD_char(sec_all[0]+48, 1);
            LCD_setxy(39,24);
            LCD_char(sec_all[1]+48, 1);
            // new
            */
          
            //  =  
            LCD_setxy(BatBarLtUpX-BatSymW-BatSymTab, BatBarLtUpY);       //      ""  
            LCD_char(129, 1); 
            i=cur_Batt/5;
            sprintf(tmp,"%-i.%-iV", i/10, i%10);
            if ((i>BatCntr[0] && i>BatCntr[1]) || df_clip)
            { LCD_setxy(BatVoltageOffsetX,BatVoltageOffsetY); LCD_wrs(tmp, 1); }  // - 10

            #ifdef AntennaCtrlUse    
                //  =  
                LCD_setxy(AntBarLtUpX-AntSymW-AntSymTab, AntBarLtUpY); LCD_char(130, 1);   //      ""  
                //sprintf(tmp,"%umA", cur_Power/5);
                sprintf(tmp,"%umA", cur_Power);      
                LCD_setxy(AntCurrentOffsetX,AntCurrentOffsetY); LCD_wrs(tmp, 1);   
            #endif
            
            
            // 
            if(CalibrTemperature[1]==0) break;
            l=cur_Temperature;
            l*=CalibrTemperature[0];
            l/=CalibrTemperature[1];
            l-=50;
            ch=' ';
            if(dir_Temperature>0) ch=134; else if(dir_Temperature<0) ch=135;
            sprintf(tmp,"%d%cC%c", (signed int)l, 131, ch);
            LCD_setxy(32,34); LCD_wrs(tmp, 1);
              
        break;
    };
}
//----------------------------------------------------------------------------------------------------

void displ_head (flash unsigned char * name) {
    //  
    flash unsigned char *p;
    unsigned char x, l=0;

    p=name;
    #ifdef Use_Font_8x8
        l=0;
        while(*p>=' ') {
            l++; 
            p++;
        };
        l=(l+4)*8;
    #else
        l=LCD_get_char_len('-'); l+=LCD_get_char_len(' '); l*=2;
        while(*p>=' ') {
            l+=LCD_get_char_len(*p); 
            p++;
        };
    #endif
    x=(WidthS-l)/2;
    LCD_setxy(x,0);
    LCD_wrsf("- ", 1);
    p=name;
    while(*p>=' ') {
        LCD_char(*p, 1);
        p++;
    };
    LCD_wrsf(" -", 1);
    LCD_dashline(0, 0, WidthS, 0);    
}
//----------------------------------------------------------------------------------------------------

extern unsigned char g_list_topitem;
extern unsigned char g_list_selitem;
extern unsigned char g_list_cnt;
extern bit f_edit;
extern bit f_edit_cur;
extern bit f_clip;
extern unsigned char pos[6];
extern unsigned char T[2];
extern MODEL_SET cur_model;
extern unsigned char cur_mode_ind;
extern unsigned char f_l;
//----------------------------------------------------------------------------------------------------

void displ_menu (void) {
    //   
    unsigned char i, att, x;
    unsigned int k; 

    do {
        f_l=0;
        dg_list_topitem=g_list_topitem;
        dg_list_selitem=g_list_selitem;
        dg_list_cnt=g_list_cnt;
        df_edit=f_edit;
        df_edit_cur=f_edit_cur;
        df_clip=f_clip;
        for(i=0; i<6; i++) dpos[i]=pos[i];
        for(i=0; i<2; i++) dT[i]=T[i];
        dcur_model=cur_model;
        dcur_mode=&dcur_model.modes[cur_mode_ind];
        dcur_mode_ind=cur_mode_ind;
    }
    while(f_l!=0);

    LCD_clear();
    switch(dpos[0]) {
        case 0: // Main screen
            main_scr();
        break;
        case 1:
            switch(dpos[1]) {
                case 0: //  (Select, Model, Copy, Options) 
                    displ_head("Main menu");
                    list_displ(menuT0);
                break;
                case 1: // Select
                    displ_head(menuT0[dpos[1]-1]);
                    list_displ_names();
                break;
                case 2: // Model
                    switch(dpos[2]) {
                        case 0:
                            displ_head(menuT0[dpos[1]-1]);
                            list_displ( menuT1);            //Controls, Channels, Name, Type, Frq, Coding,... 
                        break;
                        case 1: // CONTROLS
                            switch(dpos[3]) {
                                case 0:
                                    displ_head(menuT1[dpos[2]-1]);
                                    list_displ(menuT2);             //Ailerons, Elevator, Throttle, Rudder,...
                                break;
                                default:
                                    displ_head(menuT2[dpos[3]-1]);
                                    if(!df_edit_cur) displ_controls(dpos[3]-1, dpos[4]);
                                    else displ_curve(dpos[3]-1, dpos[5]);
                                break;
                            }
                        break;    
                        case 2: // CHANNELS
                            switch(dpos[3]) {
                                case 0:
                                    displ_head(menuT1[dpos[2]-1]);
                                    list_displ( menuT5);            //Channel 1, Channel 2,... Channel 8
                                break;
                                default:
                                    displ_head(menuT5[dpos[3]-1]);
                                    if (dpos[4]==0) displ_channel(dpos[3]-1);
                                    else if(dpos[4]==1) displ_mixer(dpos[3]-1);
                                    else if(dpos[4]==2)
                                      {
                                          displ_head(menuCh[1]);
                                          LCD_setxy(M_AskSureX,M_AskSureQuestY); 
                                          LCD_wrsf("Start process,",1);
                                          AreYouSure_LR();                                          
                                      }
                                break;
                            }
                        break;
                        case 3: //   
                            displ_head(menuT1[dpos[2]-1]); 
                            LCD_setxy(M_ModelNameX,M_ModelNameY);          
                            for (i=0; i<8; i++) {
                                  if(dpos[3]==i) { att=0; if(df_edit) att=df_clip; } else att=1;
                                  x=posx;
                                  LCD_char(dcur_model.name[i], att);
                                  if(att==0) LCD_frame(x);
                            }
                        break;    
                        case 4: //   
                            displ_head(menuT1[dpos[2]-1]);
                            LCD_setxy(M_ModelTypeX,M_ModelTypeY);
                            LCD_wrsf(TypesModel[dcur_model.type], 1);
                        break;
                        case 5: //    
                            displ_head(menuT1[dpos[2]-1]);
                            LCD_setxy(M_ChnFrqHeadX,M_ChanlY);
                            #ifdef AntennaCtrlUse
                            LCD_wrsf("Channel:", 1);
                            sprintf(tmp,"%u", dcur_model.num_freq+PLL_OffDisplNCh);
                            LCD_setxy(M_ChnFrqValueX,M_ChanlY); LCD_wrs(tmp, 1);
                            LCD_setxy(M_ChnFrqHeadX,M_FrqY); LCD_wrsf("Freq:", 1);
                            sprintf(tmp,"%u", PLL_GetFreq(dcur_model.num_freq));
                            LCD_setxy(M_ChnFrqValueX,M_FrqY); LCD_wrs(tmp, 1);
                            #else
                            LCD_wrsf("Item disabled", 1);
                            #endif
                        break;
                        case 6:  //   
                            displ_head(menuT1[dpos[2]-1]); 
                            LCD_setxy(M_ModulatNameX,M_ModulatNameY);
                            LCD_wrsf(modulNames[dcur_model.modulation], 1); 
                        break;
                        case 7: //   
                            displ_head(menuT1[dpos[2]-1]);
                            LCD_setxy(M_ChannelPcsX,M_ChannelPcsY);
                            LCD_deg12x16(dcur_model.num_ch, 1);
                        break;
                        case 8: // TIMER
                            switch(dpos[3]) {
                                case 0: 
                                    displ_head(menuT1[dpos[2]-1]);
                                    list_displ( menuT3);
                                break;
                                case 1: //   ("- Set Timer -")
                                    displ_head(menuT3[dpos[3]-1]);
                                    i=dcur_model.timer_set%60;
                                    sprintf(tmp,"%i:%i%i",dcur_model.timer_set/60, i/10, i%10);
                                    LCD_setxy(M_TimerSetX,M_TimerSetY); LCD_wrs(tmp,255);
                                break;
                                case 2:  //   
                                    displ_head(menuT3[dpos[3]-1]);
                                    LCD_setxy(M_TimerRegSelX,M_TimerRegSelY);
                                    LCD_wrsf(Timer_modes1[dcur_model.timer_mode],1);
                                break;
                            }
                      break;  
                      case 9:  //   
                            displ_head(menuT1[dpos[2]-1]);
                            LCD_setxy(M_CopyFromX,M_CopyFromY); LCD_wrsf("From:",255);
                            LCD_setxy(M_CopyToX,M_CopyToY); LCD_wrsf("To:",255);
                            if(dpos[3]==0) { att=0; if(df_edit) att=df_clip; } else att=1;
                            LCD_setxy(M_CopyFrameX, M_CopyFromY); LCD_wrsf(modeNames[dcur_model.type][dT[0]], att);
                            if(dpos[3]==1) { att=0; if(df_edit) att=df_clip; } else att=1;
                            LCD_setxy(M_CopyFrameX, M_CopyToY); LCD_wrsf(modeNames[dcur_model.type][dT[1]], att);
                            if(dpos[3]==2) att=0; else att=1;
                            LCD_setxy(M_CopyOK_X,M_CopyOK_Y); LCD_wrsf("OK", att);
                      break;
                      case 10: //      
                          displ_head(menuT1[dpos[2]-1]);
                          LCD_setxy(M_AskSureX,M_AskSureQuestY); 
                          LCD_wrsf("Model reset,",1);
                          AreYouSure_LR();                
                      break;
                      case 11: // Confirm
                          displ_head("All change");
                          list_displ( menuT7);        //Save, Cancel, Restore
                      break;  
                    }
                break;
                case 3: //   
                    displ_head(menuT0[dpos[1]-1]);
                    LCD_setxy(M_CopyFromX,M_CopyFromY); LCD_wrsf("From:",255);
                    LCD_setxy(M_CopyToX,M_CopyToY); LCD_wrsf("To:",255);
                    if(dpos[2]==0) { att=0; if(df_edit) att=df_clip; } else att=1;
                    LCD_setxy(M_CopyFrameX, M_CopyFromY); x=posx;
                    for (i=0; i<8; i++) LCD_char(EEPR_models[dT[0]].name[i], att);
                    if(att==0) LCD_frame(x);
                    if(dpos[2]==1) { att=0; if(df_edit) att=df_clip; } else att=1;
                    LCD_setxy(M_CopyFrameX, M_CopyToY); x=posx;
                    for (i=0; i<8; i++) LCD_char(EEPR_models[dT[1]].name[i], att);
                    if(att==0) LCD_frame(x);
                    if(dpos[2]==2) att=0; else att=1;
                    LCD_setxy(M_CopyOK_X,M_CopyOK_Y); LCD_wrsf("OK", att);
                break;
                case 4:
                    switch(dpos[2]) {
                            case 0:  
                                displ_head(menuT0[dpos[1]-1]);
                                list_displ( menuT4);             //Sound, Alarms,Monitor,Tachometer,Version
                            break;
                            case 1: //   ("Sound")
                                displ_head(menuT4[dpos[2]-1]);
                                LCD_setxy(M_SoundX,M_SoundY);
                                if (f_sound_en) LCD_wrsf("ON",255); 
                                else LCD_wrsf("OFF",255);
                            break;  
                            case 2:
                                switch(dpos[3]) {
                                    case 0:
                                        displ_head(menuT4[dpos[2]-1]);
                                        list_displ( menuT6);     //Battery, Antenna
                                    break;
                                    case 1: //  ("Battery")
                                        displ_head(menuT6[dpos[3]-1]);
                                        for(i=0, x=M_BatteryPosY; i<3; i++, x=x+M_BatteryBarHgt) {
                                            if(dpos[4]==i && !df_edit) att=0; else att=1;
                                            if(att==0) LCD_fillrect(M_BatBarX, x-3, M_BatBarX+M_BatBarLen, x-3+M_BatteryBarHgt, 1);
                                            LCD_setxy(M_BatThemeX,x); LCD_wrsf(menuT8[i], att);
                                            sprintf(tmp,"%-i.%-i", BatCntr[i]/10, BatCntr[i]%10);
                                            if(dpos[4]==i && df_edit) att=df_clip; else att=1;
                                            LCD_setxy(M_BatVoltageX,x); LCD_wrs(tmp, att);
                                        };
                                    break;
                                    case 2: //  ("Antenna")
                                        displ_head(menuT6[dpos[3]-1]);
                                        sprintf(tmp,"Alarm: %i%c", gAntCntr, '%');
                                        LCD_setxy(M_AntennaX,M_AntennaY); LCD_wrs(tmp, 1);
                                    break;
                                }
                            break;  
                            case 3: // "Monitor"
                                displ_head(menuT4[dpos[2]-1]);
                                displ_monitor();
                            break;
                            case 4: //  ("Tachometer")
                                displ_head(menuT4[dpos[2]-1]);
                                for(i=0, k=0; i<SIZE_RPM_BUFF; i++) k+=gRPM[i];
                                k=k*(40/2);
                                sprintf(tmp,"%u RPM", k);
                                LCD_setxy(M_TachometerX,M_TachometerY); LCD_wrs(tmp, 1);
                            break;
                            case 5: //       ("Version")
                                displ_head(menuT4[dpos[2]-1]);
                                LCD_setxy(M_VersionX,M_VersionY); LCD_wrsf(_str_VER, 1);
                                LCD_setxy(M_CopyrightX,M_CopyrightY); LCD_wrsf(_str_Co, 1);
                            break;  
                    }
                break;
            }
        break;
    };      
    LCD_refresh();
}
//----------------------------------------------------------------------------------------------------